lists.openwall.net   lists  /  announce  owl-users  owl-dev  john-users  john-dev  passwdqc-users  yescrypt  popa3d-users  /  oss-security  kernel-hardening  musl  sabotage  tlsify  passwords  /  crypt-dev  xvendor  /  Bugtraq  Full-Disclosure  linux-kernel  linux-netdev  linux-ext4  linux-hardening  linux-cve-announce  PHC 
Open Source and information security mailing list archives
 
Hash Suite: Windows password security audit tool. GUI, reports in PDF.
[<prev] [next>] [day] [month] [year] [list]
Message-Id: <20250127211737.179059-1-irogers@google.com>
Date: Mon, 27 Jan 2025 13:17:37 -0800
From: Ian Rogers <irogers@...gle.com>
To: Peter Zijlstra <peterz@...radead.org>, Ingo Molnar <mingo@...hat.com>, 
	Arnaldo Carvalho de Melo <acme@...nel.org>, Namhyung Kim <namhyung@...nel.org>, 
	Mark Rutland <mark.rutland@....com>, 
	Alexander Shishkin <alexander.shishkin@...ux.intel.com>, Jiri Olsa <jolsa@...nel.org>, 
	Ian Rogers <irogers@...gle.com>, Adrian Hunter <adrian.hunter@...el.com>, 
	Kan Liang <kan.liang@...ux.intel.com>, James Clark <james.clark@...aro.org>, 
	Weilin Wang <weilin.wang@...el.com>, linux-perf-users@...r.kernel.org, 
	linux-kernel@...r.kernel.org
Subject: [PATCH v1] perf test: Skip Intel TPEBS under hypervisor

Intel TPEBS test skips on non-Intel CPUs. On Intel CPUs under a
hypervisor the cache-misses event may not be present. Skip the test
under this condition.

Refactor the output code to be placed in a file so that on a signal
the file can be dumped. This was necessary to catch the issue above as
the failing perf record command would fail without output.

Signed-off-by: Ian Rogers <irogers@...gle.com>
---
 .../perf/tests/shell/test_stat_intel_tpebs.sh | 35 +++++++++++--------
 1 file changed, 21 insertions(+), 14 deletions(-)

diff --git a/tools/perf/tests/shell/test_stat_intel_tpebs.sh b/tools/perf/tests/shell/test_stat_intel_tpebs.sh
index 695dcb93bb5e..1b61b219cd2f 100755
--- a/tools/perf/tests/shell/test_stat_intel_tpebs.sh
+++ b/tools/perf/tests/shell/test_stat_intel_tpebs.sh
@@ -20,31 +20,38 @@ then
   exit 2
 fi
 
+stat_output=$(mktemp /tmp/__perf_stat_tpebs_output.XXXXX)
+
 cleanup() {
+  rm -rf "${stat_output}"
   trap - EXIT TERM INT
 }
 
 trap_cleanup() {
   echo "Unexpected signal in ${FUNCNAME[1]}"
+  cat "${stat_output}"
   cleanup
   exit 1
 }
 trap trap_cleanup EXIT TERM INT
 
-# Use this event for testing because it should exist in all platforms
-event=cache-misses:R
-
-# Hybrid platforms output like "cpu_atom/cache-misses/R", rather than as above
-alt_name=/cache-misses/R
+# Event to be used in tests
+event=cache-misses
 
-# Without this cmd option, default value or zero is returned
-#echo "Testing without --record-tpebs"
-#result=$(perf stat -e "$event" true 2>&1)
-#[[ "$result" =~ $event || "$result" =~ $alt_name ]] || exit 1
+if ! perf stat  -e "${event}:p" --record-tpebs -a sleep 0.01
+then
+  echo "Missing ${event} support"
+  exit 2
+fi
 
 test_with_record_tpebs() {
   echo "Testing with --record-tpebs"
-  result=$(perf stat -e "$event" --record-tpebs -a sleep 0.01 2>&1)
+  if ! perf stat -e "${event}" --record-tpebs -a sleep 0.01 > "${stat_output}" 2>&1
+  then
+    echo "Testing with --record-tpebs [Failed perf stat]"
+    cat "${stat_output}"
+    exit 1
+  fi
 
   # Expected output:
   # $ perf stat --record-tpebs -e cache-misses:R -a sleep 0.01
@@ -57,16 +64,16 @@ test_with_record_tpebs() {
   #                  0      cache-misses:R
   #
   #        0.013963299 seconds time elapsed
-  if [[ ! "$result" =~ "perf record" ]]
+  if ! grep "perf record" "${stat_output}"
   then
     echo "Testing with --record-tpebs [Failed missing perf record]"
-    echo "$result"
+    cat "${stat_output}"
     exit 1
   fi
-  if [[ ! "$result" =~ $event && ! "$result" =~ $alt_name ]]
+  if ! grep "${event}:R" "${stat_output}" && ! grep "/${event}/R" "${stat_output}"
   then
     echo "Testing with --record-tpebs [Failed missing event name]"
-    echo "$result"
+    cat "${stat_output}"
     exit 1
   fi
   echo "Testing with --record-tpebs [Success]"
-- 
2.48.1.262.g85cc9f2d1e-goog


Powered by blists - more mailing lists

Powered by Openwall GNU/*/Linux Powered by OpenVZ